/*************************** (C) COPYRIGHT 2017 Ping ****************************
 * 文件名  ：usart2.c
 * 描  述  ：串口2驱动代码
 * 版  本  ：V1.0
 * 作  者  ：XuZhongPing
 * 日  期  ：2017/09/04
*********************************************************************************/
#include "usart2.h"

uint8_t USART2_RX_BUF[USART2_RECV_LEN];			//最大接收缓存
uint8_t USART2_TX_BUF[USART2_SEND_LEN];			//最大发收缓存
uint8_t USART2_RX_STA = 0;       						//接收状态标记

void USART2_ReceiveHandler(uint8_t res);

/*
***********************************************************************
*	函 数 名: USART2_Init
*	功能说明: 串口2初始化
*	形    参：无
*	返 回 值: 无
***********************************************************************
*/
void USART2_Init(uint32_t bound)
{
	//GPIO端口设置
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);		//使能GPIOA时钟
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);	//使能USART2时钟
	
	//USART2_TX   PA.2
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2; 							//PA.2
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;					//复用推挽输出
	GPIO_Init(GPIOA, &GPIO_InitStructure); 									//初始化PA2
 
	//USART2_RX	  PA.3
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;		//浮空输入
	GPIO_Init(GPIOA, &GPIO_InitStructure);  								//初始化PA3

	//USART 初始化设置
	USART_InitStructure.USART_BaudRate = bound;												//一般设置为9600;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;				//字长为8位数据格式
	USART_InitStructure.USART_StopBits = USART_StopBits_1;						//一个停止位
	USART_InitStructure.USART_Parity = USART_Parity_No;								//无奇偶校验位
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//无硬件数据流控制
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;		//收发模式
	USART_Init(USART2, &USART_InitStructure); 												//初始化串口
	
	//Usart1 NVIC 配置
	NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0 ;				//抢占优先级0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;								//子优先级0
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;										//IRQ通道使能
	NVIC_Init(&NVIC_InitStructure);																		//根据指定的参数初始化VIC寄存器
   
	USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);										//开启中断
	USART_Cmd(USART2, ENABLE);                    										//使能串口 
}

/*
***********************************************************************
*	函 数 名: USART2_IRQHandler
*	功能说明: 串口2中断服务程序
*	形    参：无
*	返 回 值: 无
***********************************************************************
*/
void USART2_IRQHandler(void)
{
	uint8_t res = 0;	
	
	if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)		//接收到数据
	{	 
		res = USART_ReceiveData(USART2);											//读取接收到的数据
		USART2_ReceiveHandler(res);
	}
}

/*
***********************************************************************
*	函 数 名: USART2_SendByteData
*	功能说明: 发送一字节数据
*	形    参: 无
*	返 回 值: 无
***********************************************************************
*/
void USART2_SendByteData(uint8_t bData)
{ 
	USART_SendData(USART2, bData);
	while(USART_GetFlagStatus(USART2, USART_FLAG_TC) != SET);		//等待发送结束
}

/*
***********************************************************************
*	函 数 名: USART2_SendFrameData
*	功能说明: 发送一帧数据
*	形    参: pData -> 数据的首地址；len -> 数据的长度
*	返 回 值: 无
***********************************************************************
*/
void USART2_SendFrameData(uint8_t pDataBuf[], uint16_t len)
{
	uint16_t i = 0;
	
	USART_ClearFlag(USART2, USART_FLAG_TC);
	for(i = 0; i < len; i++)
	{
		USART2_SendByteData(pDataBuf[i]);
	}
}

/*
***********************************************************************
*	函 数 名: USART2_ReceiveHandler
*	功能说明: 串口数据接收处理程序
*	形    参: 传入串口接收到的数据
*	返 回 值: 无（影响串口接收状态USART2_RX_STA）
***********************************************************************
*/
void USART2_ReceiveHandler(uint8_t res)
{
	static uint8_t RX_Status = 0;						//接收状态
	static uint8_t CS = 0;		  						//接收核验和
	static uint8_t RX_Size = 0;							//接收通讯数据长度
	static uint8_t RX_ByteCount = 0;	  		//接收数据字节计数
	
// 	printf("U2 = %02X\r\n", res);
	
	switch(RX_Status)
	{
		case 0:	  //第一前导字节
			if(res == 0xfe){
				RX_Status = 1;
			}else{
				RX_Status = 0;
			}
			break;
			
		case 1:	  //第二前导字节
			if(res == 0xfe){
				RX_Status = 1;						//还是前导字节
			}else if(res == 0x68){
				RX_Status = 3;						//转到接收设备通讯地址
				CS = 0x68;
			}else{
				RX_Status = 0;
			}
			break;

		case 3:		//接收设备通讯地址
			USART2_RX_BUF[0] = res;
			CS += res;
			RX_Status = 4;
			break;
			
		case 4:	  //接收帧头
			if(res == 0x68){
				RX_Status = 5;						//转到接收通讯命令
				CS += 0x68;
			}else{
				RX_Status = 0;
			}
			break;
		case 5:		//接收通讯命令
			USART2_RX_BUF[1] = res;
			CS += res;
			RX_Status = 6;							//转到接收数据长度
			break;
			
		case 6:		//接收通讯数据长度
			USART2_RX_BUF[2] = res;
			CS += res;
			RX_Size = res;						//接收的数据长度
			if(RX_Size == 0x00){			//如果数据长度为0，则直接转到接收校验码
				RX_Status = 8;
			}else{
				RX_Status = 7;						//转到接收数据
			}
			break;	
			
		case 7:	  //接收N个字节数据
			if(RX_ByteCount < RX_Size-1){
				USART2_RX_BUF[RX_ByteCount + 3] = res;
				CS += res;
				RX_ByteCount++;
			}else{
				USART2_RX_BUF[RX_ByteCount + 3] = res;
				CS += res;
				RX_ByteCount = 0;					//已完成N个字节的数据接收计数归0
				RX_Status = 8;						//转到接收核验码
			}
			break;
			
		case 8:	  //接收校验
			if(CS != res){
				RX_Status = 0;
			}else{
				RX_Status = 9;						//转到接收帧尾码0x16
			}
			break;
			
		case 9:	  //接收帧尾
			if(res == 0x16){ 						//是帧尾吗？
				USART2_RX_STA = 0xfd; 		//一帧接收成功，标记接收到一帧数据通知主程序进行通讯处理
			}
			RX_Status = 0;
			break;
			
		default:  //其它
			RX_Status = 0;
			break;
	}
}

/******************** (C) COPYRIGHT 2017 Ping *****END OF FILE*******************/ 
